"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dialog_audit_component_1 = require("./../dialog-audit/dialog-audit.component");
var funcoes_component_1 = require("../../../models/funcoes.component");
var notification_component_1 = require("../../../components/notification/notification.component");
var AbstractCrud = (function () {
    function AbstractCrud(sbmHttpClient, dialog) {
        this.sbmHttpClient = sbmHttpClient;
        this.dialog = dialog;
    }
    AbstractCrud.prototype.audit = function (entity, id) {
        var _this = this;
        this.sbmHttpClient.get("/sabium/api/auditoria/aplicacao/" + _projectCodigo + "/entidade/" + entity + "/registro/" + id.selectedRowsData[0].id).subscribe(function (ret) {
            if (ret) {
                var audit = ret.data;
                audit.forEach(function (ret) {
                    ret['data'] = funcoes_component_1.FuncoesComponent.formatarData(ret.dataHora);
                    var lista = [];
                    var details = JSON.parse(ret.detalhes);
                    var keys = Object.keys(details.properties);
                    keys.forEach(function (ret) { lista.push({ "chave": ret, "valor": details.properties[ret] }); });
                    ret['detalhesLista'] = lista;
                });
                if (ret.data.length > 0) {
                    var dialogRef = _this.dialog.open(dialog_audit_component_1.DialogAuditDetail, {
                        width: '700px',
                        data: audit
                    });
                }
            }
            else {
                var notification = new notification_component_1.NotificationComponent();
                notification.show("Não existem alterações para este registro!");
            }
        });
    };
    return AbstractCrud;
}());
exports.AbstractCrud = AbstractCrud;
