"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var DialogAuditDetail = (function () {
    function DialogAuditDetail(dialog, data) {
        this.dialog = dialog;
        this.data = data;
    }
    DialogAuditDetail.prototype.onNoClick = function () {
        this.dialog.close();
    };
    return DialogAuditDetail;
}());
DialogAuditDetail.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-dialog-master-detail',
                template: "\n\n        <h5>Auditoria registro {{data[0].registroId}}</h5>\n        <hr>\n\n        <dx-data-grid [dataSource]=\"data\" [allowColumnReordering]=\"true\" \n        [masterDetail]=\"{ enabled: true, template: 'detail' }\"\n        keyExpr=\"id\"\n        [searchPanel]='{\n            visible: true,\n            width: 240,\n            placeholder: \"Procurar...\"\n        }'>\n            <dxo-paging [pageSize]=\"5\"></dxo-paging>\n            <dxo-group-panel emptyPanelText=\"Agrupar\" [visible]=\"true\"></dxo-group-panel>\n            <dxo-grouping #expand></dxo-grouping>\n            \n            <dxi-column caption=\"#\" dataField=\"id\" width=\"75\"></dxi-column>\n            <!--dxi-column caption=\"Aplica\u00E7\u00E3o\" dataField=\"aplicacao\"></dxi-column-->\n            <dxi-column caption=\"Tabela\" dataField=\"tabela\"></dxi-column>\n            <dxi-column caption=\"Opera\u00E7\u00E3o\" dataField=\"operacao\"></dxi-column>\n            <dxi-column caption=\"Usu\u00E1rio\" dataField=\"usuario\"></dxi-column>\n            <dxi-column caption=\"Data\" dataField=\"data\"></dxi-column>\n\n            <div *dxTemplate=\"let d of 'detail'\">\n                <span class=\"title-detail\">Valores Alterados</span>\n                <hr>\n                <ng-container *ngFor=\"let item of d.data.detalhesLista\">\n                    <p>{{item.chave}}: {{item.valor}}</p>\n                </ng-container>\n            </div>\n\n        </dx-data-grid>\n    ",
                styles: ["\n        .title-detail {\n            font-size: 14px;\n            font-weight: bold;\n        }\n    "]
            },] },
];
/** @nocollapse */
DialogAuditDetail.ctorParameters = function () { return [
    { type: material_1.MatDialogRef, },
    { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
]; };
exports.DialogAuditDetail = DialogAuditDetail;
