"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ngx-translate/core");
var http_1 = require("@angular/http");
var core_2 = require("@angular/core");
var sharedService_1 = require("../../models/sharedService");
var abstract_ngmodel_1 = require("../../models/abstract.ngmodel");
var EditorComponent = (function (_super) {
    __extends(EditorComponent, _super);
    function EditorComponent(_translateService, _http, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._sharedService = _sharedService;
        _this.isCreated = false;
        _this.options = [
            ['bold', 'italic', 'underline', 'strike'],
            ['blockquote', 'image', 'link'],
            [{ 'header': 1 }, { 'header': 2 }],
            [{ 'list': 'ordered' }, { 'list': 'bullet' }],
            [{ 'script': 'sub' }, { 'script': 'super' }],
            [{ 'indent': '-1' }, { 'indent': '+1' }],
            [{ 'direction': 'rtl' }],
            [{ 'size': ['small', false, 'large', 'huge'] }],
            [{ 'header': [1, 2, 3, 4, 5, 6, false] }],
            [{ 'color': [] }, { 'background': [] }],
            [{ 'font': [] }],
            [{ 'align': [] }],
            ['clean'] // remove formatting button
        ];
        sbmEditorComponent.push(_this);
        return _this;
    }
    Object.defineProperty(EditorComponent.prototype, "html", {
        get: function () {
            return this._html;
        },
        set: function (html) {
            if (html) {
                this._html = html;
                this.value = html;
            }
        },
        enumerable: true,
        configurable: true
    });
    EditorComponent.prototype.ngOnInit = function () {
        this.validar(this.securityId);
        this.classCss += ' ' + this.css;
    };
    EditorComponent.prototype.ngAfterViewInit = function () {
        // this.onChangeValue.subscribe((ret) => {
        //     if (ret) {
        //         if (!this.isCreated) {
        var _this = this;
        this.quill = new Quill('#editor', {
            theme: 'snow',
            modules: {
                toolbar: this.options,
            },
        });
        this.isCreated = true;
        // this.quill.setText(ret.replace(/<[^>]+>/g, ''));
        // }
        this.quill.on('text-change', function (delta, oldDelta, source) {
            if (source == 'api') {
                _this.value = $(_this.quill.root).html();
            }
            else if (source == 'user') {
                _this.value = $(_this.quill.root).html();
            }
        });
        //     } else {
        //         this.editor.nativeElement.innerHTML = '<p></p>'
        //     }
        // })
    };
    return EditorComponent;
}(abstract_ngmodel_1.AbstractNgModel));
EditorComponent.decorators = [
    { type: core_2.Component, args: [{
                selector: 'sbm-editor',
                template: require('./editor.component.html'),
                host: {
                    '[class]': 'classCss',
                },
                providers: [
                    abstract_ngmodel_1.MakeProvider(EditorComponent),
                    { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_2.forwardRef(function () { return EditorComponent; }) }
                ]
            },] },
];
/** @nocollapse */
EditorComponent.ctorParameters = function () { return [
    { type: core_1.TranslateService, },
    { type: http_1.Http, },
    { type: sharedService_1.SharedService, },
]; };
EditorComponent.propDecorators = {
    'editor': [{ type: core_2.ViewChild, args: ['editor',] },],
    'html': [{ type: core_2.Input },],
};
exports.EditorComponent = EditorComponent;
