"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var abstract_ngmodel_1 = require("../../../models/abstract.ngmodel");
require("rxjs/add/operator/map");
var core_2 = require("@ngx-translate/core");
var sharedService_1 = require("../../../models/sharedService");
var http_1 = require("@angular/http");
//
var MoneyComponent = (function (_super) {
    __extends(MoneyComponent, _super);
    function MoneyComponent(_translateService, _http, _el, _sharedService) {
        var _this = _super.call(this, _sharedService, _translateService, _http) || this;
        _this._translateService = _translateService;
        _this._http = _http;
        _this._el = _el;
        _this._sharedService = _sharedService;
        _this.prefix = 'R$';
        _this.decimal = ',';
        _this.min = '';
        _this.max = '';
        _this.thousands = '.';
        _this.decimalDigits = '2';
        _this.digitAlign = 'right';
        _this.onFocus = '';
        _this._onFocus = new core_1.EventEmitter();
        _this._options = {};
        _this._valueChecked = true;
        _this.inputValid = true;
        _this.msgInvalid = false;
        _this.labelWidth = '';
        _this.msgError = 'Campo Inválido';
        sbmInputMoneyComponent.push(_this);
        return _this;
    }
    MoneyComponent.prototype.blur = function ($event) {
        this._onBlur.emit($event);
        if (this.onBlur != '') {
            window[this.onBlur]($event);
        }
    };
    MoneyComponent.prototype.focus = function ($event) {
        this._onFocus.emit($event);
        if (this.onFocus != '') {
            window[this.onFocus]($event);
        }
    };
    MoneyComponent.prototype.click = function ($event) {
        this._onClick.emit($event);
        if (this.onClick != '') {
            window[this.onClick]($event);
        }
    };
    MoneyComponent.prototype.ngAfterViewInit = function () {
        $(this.money.nativeElement).attr('style', this.styleCss);
        if (this.digitAlign == 'right') {
            $(this.money.nativeElement).css('direction', 'rtl');
        }
        else if (this.digitAlign == 'left') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
        else if (this.digitAlign == 'center') {
            $(this.money.nativeElement).css('direction', 'ltr');
        }
    };
    MoneyComponent.prototype.keyup = function ($event) {
        this._onKeyup.emit($event);
        if (this.onKeyup != '') {
            window[this.onKeyup]($event);
        }
    };
    MoneyComponent.prototype.ngOnInit = function () {
        _super.prototype.validar.call(this, this.securityId);
        this._options = {
            prefix: this.prefix + ' ',
            thousands: this.thousands,
            decimal: this.decimal,
            align: this.digitAlign,
            precision: this.decimalDigits
        };
        this.css += ' sbm-input';
        this.classCss += ' ' + this.css;
    };
    return MoneyComponent;
}(abstract_ngmodel_1.AbstractNgModel));
MoneyComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-money',
                template: require('./money.component.html'),
                host: {
                    '[class]': 'classCss'
                },
                providers: [
                    abstract_ngmodel_1.MakeProvider(MoneyComponent),
                    { provide: abstract_ngmodel_1.AbstractNgModel, useExisting: core_1.forwardRef(function () { return MoneyComponent; }) }
                ],
            },] },
];
/** @nocollapse */
MoneyComponent.ctorParameters = function () { return [
    { type: core_2.TranslateService, },
    { type: http_1.Http, },
    { type: core_1.ElementRef, },
    { type: sharedService_1.SharedService, },
]; };
MoneyComponent.propDecorators = {
    'money': [{ type: core_1.ViewChild, args: ['money',] },],
    'prefix': [{ type: core_1.Input },],
    'decimal': [{ type: core_1.Input },],
    'min': [{ type: core_1.Input },],
    'max': [{ type: core_1.Input },],
    'thousands': [{ type: core_1.Input },],
    'decimalDigits': [{ type: core_1.Input, args: ['decimaldigits',] },],
    'digitAlign': [{ type: core_1.Input, args: ['digitalign',] },],
    'onFocus': [{ type: core_1.Input, args: ['onfocus',] },],
    '_onFocus': [{ type: core_1.Output },],
};
exports.MoneyComponent = MoneyComponent;
