"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var http_1 = require("@angular/http");
var devextreme_angular_1 = require("devextreme-angular");
var sbm_module_1 = require("../../../sbm.module");
var ng2_currency_mask_1 = require("ng2-currency-mask");
var ng2_webstorage_1 = require("ng2-webstorage");
var core_2 = require("@ngx-translate/core");
var TabGenericComponent = (function () {
    function TabGenericComponent(compiler, _http) {
        this.compiler = compiler;
        this._http = _http;
        this.id = '';
        this.hidden = false;
        this._isPath = false;
        this.ocultarCarregamento = false;
        this.modules = [
            common_1.CommonModule,
            forms_1.FormsModule,
            forms_1.ReactiveFormsModule,
            http_1.HttpModule,
            devextreme_angular_1.DevExtremeModule,
            sbm_module_1.SbmModule.forRoot(),
            ng2_currency_mask_1.CurrencyMaskModule,
            ng2_webstorage_1.Ng2Webstorage.forRoot({ prefix: '__SBM-SHARED__', separator: '/' }),
            core_2.TranslateModule.forRoot()
        ];
        this.compDinamic = [];
    }
    Object.defineProperty(TabGenericComponent.prototype, "isPath", {
        get: function () {
            return this._isPath;
        },
        set: function (val) {
            this._isPath = val;
        },
        enumerable: true,
        configurable: true
    });
    TabGenericComponent.prototype.createComponentFactorySync = function (compiler, metadata, componentClass) {
        var cmpClass = componentClass || (function () {
            function RuntimeComponent() {
            }
            return RuntimeComponent;
        }());
        var decoratedCmp = core_1.Component(metadata)(cmpClass);
        this.compDinamic.push(decoratedCmp);
        var TabRuntimeComponentModule = (function () {
            function TabRuntimeComponentModule() {
            }
            return TabRuntimeComponentModule;
        }());
        TabRuntimeComponentModule.decorators = [
            { type: core_1.NgModule, args: [{
                        imports: this.modules,
                        declarations: this.compDinamic,
                        schemas: [core_1.CUSTOM_ELEMENTS_SCHEMA, core_1.NO_ERRORS_SCHEMA]
                    },] },
        ];
        /** @nocollapse */
        TabRuntimeComponentModule.ctorParameters = function () { return []; };
        var module = compiler.compileModuleAndAllComponentsSync(TabRuntimeComponentModule);
        return module.componentFactories.find(function (f) { return f.componentType === decoratedCmp; });
    };
    TabGenericComponent.prototype.compileTemplate = function (template) {
        var _this = this;
        if (this.isPath) {
            this._http.get(template).subscribe(function (ret) {
                _this.ocultarCarregamento = true;
                _this.compileTemplateHtml(ret._body);
            });
        }
        else {
            this.ocultarCarregamento = true;
            this.compileTemplateHtml(template);
        }
    };
    TabGenericComponent.prototype.compileTemplateHtml = function (template) {
        var jsFilesUrls = [];
        var regex = /src=(["'])(.+\.js)\1/g;
        var matchJsUrls = regex.exec(template);
        while (matchJsUrls !== null) {
            jsFilesUrls.push(matchJsUrls[2]);
            matchJsUrls = regex.exec(template);
        }
        if (jsFilesUrls.length) {
            for (var i in jsFilesUrls) {
                var s = document.createElement('script');
                s.src = jsFilesUrls[i];
                document.getElementsByTagName('head')[0].appendChild(s);
            }
        }
        var metadata = {
            selector: "tab-runtime-app-principal",
            template: template
        };
        var factory = this.createComponentFactorySync(this.compiler, metadata, null);
        if (this.componentRef) {
            this.componentRef.destroy();
            this.componentRef = null;
        }
        this.componentRef = this.container.createComponent(factory);
    };
    TabGenericComponent.prototype.ngOnInit = function () {
    };
    TabGenericComponent.prototype.ngAfterViewInit = function () {
    };
    return TabGenericComponent;
}());
TabGenericComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-tab-generic',
                template: require('./tab-generic.component.html'),
                host: {
                    '[id]': 'id',
                    '[hidden]': 'hidden',
                },
                styles: [require('./tab-generic.component.css')],
            },] },
];
/** @nocollapse */
TabGenericComponent.ctorParameters = function () { return [
    { type: core_1.Compiler, },
    { type: http_1.Http, },
]; };
TabGenericComponent.propDecorators = {
    'container': [{ type: core_1.ViewChild, args: ['container', { read: core_1.ViewContainerRef },] },],
};
exports.TabGenericComponent = TabGenericComponent;
