"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var tab_component_1 = require("../tab.component");
var tab_generic_component_1 = require("../tab-generic/tab-generic.component");
var sharedService_1 = require("../../../models/sharedService");
var funcoes_component_1 = require("../../../models/funcoes.component");
var abstract_tabs_1 = require("../abstract-tabs/abstract.tabs");
var select_component_1 = require("../../select/select.component");
var TabsChromeComponent = (function (_super) {
    __extends(TabsChromeComponent, _super);
    function TabsChromeComponent(componentFactoryResolver, compiler, _sharedService) {
        var _this = _super.call(this) || this;
        _this.componentFactoryResolver = componentFactoryResolver;
        _this.compiler = compiler;
        _this._sharedService = _sharedService;
        _this.css = 'sbm-tabs';
        _this.layout = 'line';
        _this.padding = '5px';
        _this.closeButton = false;
        _this.id = '';
        _this.isPath = false;
        _this.onTabClick = new core_1.EventEmitter();
        _this.onAfterViewInit = new core_1.EventEmitter();
        _this.onSelectedTab = new core_1.EventEmitter();
        _this.onRemoveTab = new core_1.EventEmitter();
        _this.tabsDinamic = [];
        _this.indexActive = 0;
        _this.tabsSaved = [];
        _this._tabs = [];
        _this.modulesDinamic = [];
        _this.compDinamic = [];
        _this._columns = 'col l12 s12 m12 sbm-tabs';
        return _this;
    }
    Object.defineProperty(TabsChromeComponent.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = "col l" + value + " s12 m12";
            this._columns += ' ' + this.css;
        },
        enumerable: true,
        configurable: true
    });
    TabsChromeComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.savedTab = this._sharedService.getLocalStorageShared('tab-active' + this.id);
        if (this.savedTab) {
            this.indexActive = this.savedTab.index;
        }
        this.onTabAdd.subscribe(function (tabEl) {
            $(tabEl).attr('data-tab', _this.tabsSaved[_this.tabsSaved.length - 1].id);
        });
        this.onTabRemove.subscribe(function (tabEl) {
            _this.tabsSaved.forEach(function (itm, index) {
                if ($(tabEl).attr('data-tab') == itm['id']) {
                    _this.tabsSaved.splice(index, 1);
                    _this._sharedService.setLocalStorageShared('sbm-saved-dynamic' + _this.id, _this.tabsSaved, false);
                }
            });
            var a = [];
            var b = [];
            $(".chrome-tabs").find('.chrome-tabs-content').find('.chrome-tab').each(function (index, element) {
                a.push($(element).attr('data-tab'));
            });
            $(_this.dinamicContainer.nativeElement).children().each(function (index, tab) {
                b.push($(tab).attr('id'));
            });
            var diff = b.filter(function (i) { return a.indexOf(i) < 0; });
            diff.map(function (itm) {
                if (itm) {
                    document.getElementById(itm).style.display = 'none';
                }
            });
        });
        this.onActiveTabChange.subscribe(function (tabEl) {
            $(_this.chromeTabs.nativeElement).find('.chrome-tab').each(function (index, element) {
                if ($(element).attr('data-tab') == $(tabEl).attr('data-tab')) {
                    _this._sharedService.setLocalStorageShared('tab-active' + _this.id, { "index": index, id: $(element).attr('data-tab') }, false);
                }
                if ($(element).attr('data-tab') == $(tabEl).attr('data-tab')) {
                    _this._sharedService.setLocalStorageShared('tab-active' + _this.id, { "index": index, id: $(element).attr('data-tab') }, false);
                }
                _this._tabs.forEach(function (item, index) {
                    if ($(tabEl).attr('data-tab') == item.idGerenarated) {
                        item.active = true;
                    }
                    else {
                        item.active = false;
                    }
                });
                $(_this.dinamicContainer.nativeElement).children().each(function (index, tab) {
                    if ($(tabEl).attr('data-tab') == $(tab).attr('id')) {
                        $("#" + tab.id).css('display', 'block');
                    }
                    else {
                        $("#" + tab.id).css('display', 'none');
                    }
                });
            });
        });
        select_component_1.SelectComponent._onActionButtons.subscribe(function (ret) {
            console.log(ret);
        });
    };
    TabsChromeComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        $(document).ready(function () {
            _this.init(_this.chromeTabs.nativeElement, {
                tabOverlapDistance: 14,
                minWidth: 45,
                maxWidth: 243
            });
            _this._tabs = _this.tabs.toArray();
            if (_this.tabs.length > 0) {
                _this.tabs.first.active = true;
            }
        });
        this.observeList();
        setTimeout(function () {
            var saveDinamic = _this._sharedService.getLocalStorageShared('sbm-saved-dynamic' + _this.id);
            if (saveDinamic) {
                if (saveDinamic.length > 0) {
                    saveDinamic.forEach(function (itm) {
                        if (itm['html']) {
                            _this.tabsDinamic.push({
                                _label: itm['title'],
                                disabled: itm['disabled'] ? true : false,
                                isActive: itm['isActive'] ? true : false,
                                html: itm['html'],
                                isPath: itm['isPath'],
                                id: itm['idComp'],
                                icon: itm['favicon']
                            });
                        }
                    });
                }
            }
            if (_this.tabsSaved[_this.indexActive]) {
                $(_this.dinamicContainer.nativeElement).children().each(function (index, element) {
                    if ($(element).attr('id') == _this.tabsSaved[_this.indexActive]['id']) {
                        $(element).css('display', 'block');
                    }
                    else {
                        $(element).css('display', 'none');
                    }
                    $(_this.chromeTabs.nativeElement).find('.chrome-tab').each(function (index, element) {
                        if ($(element).attr('data-tab') == _this.tabsSaved[_this.indexActive]['id']) {
                            _this.setCurrentTab(element);
                        }
                    });
                });
            }
            _this.fixZIndexes();
        }, 1000);
    };
    TabsChromeComponent.prototype.observeList = function () {
        var me = this;
        Object.defineProperty(this.tabsDinamic, "push", {
            configurable: false,
            enumerable: false,
            writable: false,
            value: function () {
                for (var i = 0, n = this.length, l = arguments.length; i < l; i++, n++) {
                    arguments[i]['idGerenarated'] = funcoes_component_1.FuncoesComponent.makeId();
                    me.tabsSaved.push({
                        title: arguments[i]['_label'],
                        id: arguments[i]['idGerenarated'],
                        html: arguments[i]['html'],
                        isPath: arguments[i]['isPath'],
                        idComp: arguments[i]['id'],
                        favicon: arguments[i]['icon']
                    });
                    me.addTabComp({
                        title: arguments[i]['_label'],
                        url: arguments[i]['id'],
                        favicon: arguments[i]['icon']
                    });
                    me.createComponenteDynamic(arguments[i]['html'], {
                        title: arguments[i]['_label'],
                        id: arguments[i]['idGerenarated'],
                        html: arguments[i]['html'],
                        isPath: arguments[i]['isPath'],
                        idComp: arguments[i]['id'],
                        favicon: arguments[i]['icon']
                    });
                    me._sharedService.setLocalStorageShared('sbm-saved-dynamic' + me.id, me.tabsSaved, false);
                }
                return n;
            }
        });
    };
    TabsChromeComponent.prototype.removeDinamic = function (event, tab) {
        var _this = this;
        event.preventDefault();
        event.stopPropagation();
        this.tabsDinamic.map(function (item, index) {
            if (JSON.stringify(item) == JSON.stringify(tab)) {
                _this.tabsDinamic.splice(index, 1);
            }
        });
        this.onRemoveTab.emit(tab);
    };
    TabsChromeComponent.prototype.selectedTab = function (tab) {
        var _this = this;
        $(this.chromeTabs.nativeElement).find('.chrome-tab').each(function (index, element) {
            if ($(element).children(".chrome-tab-title").text() == tab) {
                _this.setCurrentTab(element);
                _this.onSelectedTab.emit(element);
            }
        });
        // $(".owl-dateTime-dialog").css("display", "none");
    };
    TabsChromeComponent.prototype.removedTab = function (tab) {
        var _this = this;
        $(this.chromeTabs.nativeElement).find('.chrome-tab').each(function (index, element) {
            if ($(element).children(".chrome-tab-title").text() == tab) {
                _this.removeTab(element);
                _this.onRemoveTab.emit(element);
            }
        });
        // $(".owl-dateTime-dialog").css("display", "none");
    };
    TabsChromeComponent.prototype.addTab = function (label, content, isPath, id, disabled, isActive, icon) {
        if (!this.tabsSaved.some(function (t) { return t.idComp && t.idComp === id; })) {
            this.tabsDinamic.push({
                _label: label,
                disabled: disabled ? true : false,
                isActive: isActive ? true : false,
                html: content,
                isPath: isPath,
                id: id,
                icon: icon
            });
        }
        else {
            this.selectTab(id);
        }
    };
    TabsChromeComponent.prototype.selectTab = function (tab) {
        var _this = this;
        if (tab) {
            $(this.chromeTabs.nativeElement).find('.chrome-tab').each(function (index, element) {
                if ($(element).attr('data-url') == tab) {
                    _this.setCurrentTab(element);
                    _this.onSelectedTab.emit(element);
                }
            });
        }
    };
    TabsChromeComponent.prototype.createComponenteDynamic = function (html, data) {
        // Cria um componente IFrame
        var factory = this.componentFactoryResolver.resolveComponentFactory(tab_generic_component_1.TabGenericComponent);
        var injector = core_1.ReflectiveInjector.fromResolvedProviders([], this.container.parentInjector);
        var res = factory.create(injector);
        if (this.modulesDinamic.length > 0) {
            var modules = res.instance.modules.concat(this.modulesDinamic);
            res.instance.modules = modules;
        }
        res.instance.id = data.id;
        res.instance.isPath = data['isPath'];
        res.instance.compileTemplate(html);
        res.changeDetectorRef.detectChanges();
        this.container.insert(res.hostView);
        var a = [];
        var b = [];
        $('.chrome-tabs').find('.chrome-tabs-content').find('.chrome-tab').each(function (index, element) {
            a.push($(element).attr('data-tab'));
        });
        $(this.dinamicContainer.nativeElement).children().each(function (index, tab) {
            b.push($(tab).attr('id'));
        });
        var diff = b.filter(function (i) { return a.indexOf(i) < 0; });
        diff.map(function (itm) {
            if (itm) {
                document.getElementById(itm).remove();
            }
        });
    };
    return TabsChromeComponent;
}(abstract_tabs_1.AbstractTabs));
TabsChromeComponent.decorators = [
    { type: core_1.Component, args: [{
                selector: 'sbm-tabs-chrome',
                template: require('./tabs-chrome.component.html'),
                styles: [require('./tabs-chrome.component.css')],

                host: {
                    '[class]': 'columns'
                }
            },] },
];
/** @nocollapse */
TabsChromeComponent.ctorParameters = function () { return [
    { type: core_1.ComponentFactoryResolver, },
    { type: core_1.Compiler, },
    { type: sharedService_1.SharedService, },
]; };
TabsChromeComponent.propDecorators = {
    'container': [{ type: core_1.ViewChild, args: ['container', { read: core_1.ViewContainerRef },] },],
    'type': [{ type: core_1.Input },],
    'el': [{ type: core_1.ViewChild, args: ['tabs',] },],
    'tabsContent': [{ type: core_1.ViewChild, args: ['tabsContent',] },],
    'ul': [{ type: core_1.ViewChild, args: ['ul', { read: core_1.ViewContainerRef },] },],
    'chromeTabs': [{ type: core_1.ViewChild, args: ['chromeTabs',] },],
    'dinamicContainer': [{ type: core_1.ViewChild, args: ['dinamicContainer',] },],
    'css': [{ type: core_1.Input },],
    'layout': [{ type: core_1.Input },],
    'padding': [{ type: core_1.Input },],
    'closeButton': [{ type: core_1.Input },],
    'id': [{ type: core_1.Input },],
    'isPath': [{ type: core_1.Input },],
    'onTabClick': [{ type: core_1.Output },],
    'onAfterViewInit': [{ type: core_1.Output },],
    'onSelectedTab': [{ type: core_1.Output },],
    'onRemoveTab': [{ type: core_1.Output },],
    'tabs': [{ type: core_1.ContentChildren, args: [tab_component_1.TabComponent,] },],
    'columns': [{ type: core_1.Input },],
};
exports.TabsChromeComponent = TabsChromeComponent;
