"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var FilterPipe = (function () {
    function FilterPipe() {
    }
    FilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item.value.toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1 || item.label.toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    return FilterPipe;
}());
FilterPipe.decorators = [
    { type: core_1.Pipe, args: [{
                name: 'sbmFilter'
            },] },
];
/** @nocollapse */
FilterPipe.ctorParameters = function () { return []; };
exports.FilterPipe = FilterPipe;
var SelectFilterPipe = (function () {
    function SelectFilterPipe() {
    }
    SelectFilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item['label'].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    return SelectFilterPipe;
}());
SelectFilterPipe.decorators = [
    { type: core_1.Pipe, args: [{
                name: 'selectFilter'
            },] },
];
/** @nocollapse */
SelectFilterPipe.ctorParameters = function () { return []; };
exports.SelectFilterPipe = SelectFilterPipe;
var MultiSelectFilterPipe = (function () {
    function MultiSelectFilterPipe() {
    }
    MultiSelectFilterPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        return items.filter(function (item) { return item['label'].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1; });
    };
    return MultiSelectFilterPipe;
}());
MultiSelectFilterPipe.decorators = [
    { type: core_1.Pipe, args: [{
                name: 'multiselectFilter'
            },] },
];
/** @nocollapse */
MultiSelectFilterPipe.ctorParameters = function () { return []; };
exports.MultiSelectFilterPipe = MultiSelectFilterPipe;
var FilterAllPipe = (function () {
    function FilterAllPipe() {
    }
    FilterAllPipe.prototype.transform = function (items, filter) {
        if (!items || !filter || filter.length < 3) {
            return items;
        }
        var ret = [];
        items.map(function (item) {
            var keys = Object.keys(item);
            keys.map(function (key) {
                if (typeof item[key] == 'string') {
                    if (item[key].toString().toLowerCase().indexOf(filter.toLowerCase()) !== -1) {
                        ret.push(item);
                    }
                }
            });
        });
        return ret.filter(function (elem, pos, self) {
            return self.indexOf(elem) == pos;
        });
    };
    return FilterAllPipe;
}());
FilterAllPipe.decorators = [
    { type: core_1.Pipe, args: [{
                name: 'sbmFilterAll'
            },] },
];
/** @nocollapse */
FilterAllPipe.ctorParameters = function () { return []; };
exports.FilterAllPipe = FilterAllPipe;
