"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var SbmHttpClientService = (function () {
    function SbmHttpClientService(http) {
        this.http = http;
    }
    SbmHttpClientService.prototype.changeUrl = function (url) {
        if (/^\/sabium-gerenciador\/(.+)?/g.test(url)) {
            url = url.replace("/sabium-gerenciador/", "/sabium/");
        }
        else if (/^\/sabium-framework\/(.+)?/g.test(url)) {
            url = url.replace("/sabium-framework/", "/sabium/");
        }
        else if (url.indexOf("/sabium-gerenciador-bpm/") >= 0) {
            url = url.replace("/sabium-gerenciador-bpm/", "/sabium-bpm/");
        }
        return url;
    };
    SbmHttpClientService.prototype.get = function (url) {
        url = this.changeUrl(url);
        return this.http.get(url);
    };
    SbmHttpClientService.prototype.post = function (url, body) {
        url = this.changeUrl(url);
        return this.http.post(url, body);
    };
    SbmHttpClientService.prototype.put = function (url, body) {
        url = this.changeUrl(url);
        return this.http.put(url, body);
    };
    SbmHttpClientService.prototype.delete = function (url, body) {
        url = this.changeUrl(url);
        return this.http.delete(url);
    };
    return SbmHttpClientService;
}());
SbmHttpClientService.decorators = [
    { type: core_1.Injectable },
];
/** @nocollapse */
SbmHttpClientService.ctorParameters = function () { return [
    { type: http_1.HttpClient, },
]; };
exports.SbmHttpClientService = SbmHttpClientService;
